/*
 * IAP.c
 *
 *  Created on: 20220312
 *      Author: User
 */

/* Includes ------------------------------------------------------------------*/
#include <main.h>

uint8_t EEPROM_Array[4] = {0}; //¶ȵ
uint16_t Save_Value1;
uint16_t Save_Value2;
static uint8_t Flash_ReadData(uint16_t);		//һֽ
static void FLASH_WriteData(uint8_t, uint16_t); //дһֽ(д֮ǰҪȲ)
static void Flash_EraseBlock(uint16_t);			//
static void Get_TempValue(void);				//ָ¶
static void Save_TempValue(void);
static void Flash_ReadArr(unsigned int fui_Address, unsigned char fuc_Length, unsigned char *fucp_SaveArr);
static void Flash_WriteArr(unsigned int fui_Address, unsigned char fuc_Length, unsigned char *fucp_SaveArr);

/* Public variables-----------------------------------------------------------*/
IAP_t xdata IAP =
	{
		EEPROM_Array,
		Save_TempValue,
		Get_TempValue};

/*
 * @name   Get_TempValue
 * @brief  ȡ¶ȵֵ
 * @param  None
 * @retval None
 */
static void Get_TempValue(void)
{
	Flash_ReadArr(EEPROM_Array_ADDR, 4, EEPROM_Array);
	Public.Setting_Temp1 = EEPROM_Array[0];
	Public.Setting_Temp1 <<= 8;
	Public.Setting_Temp1 |= EEPROM_Array[1];
	Public.Setting_Temp2 = EEPROM_Array[2];
	Public.Setting_Temp2 <<= 8;
	Public.Setting_Temp2 |= EEPROM_Array[3];
	Save_Value1 = Public.Setting_Temp1;
	Save_Value2 = Public.Setting_Temp2;
}
/*
 * @name   Save_TempValue
 * @brief  ¶ȵֵ
 * @param  None
 * @retval None
 */
static void Save_TempValue(void)
{
	if ((Save_Value1 != Public.Setting_Temp1) || (Save_Value2 != Public.Setting_Temp2))
	{

		IAP.EEPROM_Array[0] = (Public.Setting_Temp1 >> 8) & 0xFF;
		IAP.EEPROM_Array[1] = Public.Setting_Temp1 & 0xFF;
		IAP.EEPROM_Array[2] = (Public.Setting_Temp2 >> 8) & 0xFF;
		IAP.EEPROM_Array[3] = Public.Setting_Temp2 & 0xFF;
		Flash_EraseBlock(EEPROM_Array_ADDR);
		Flash_WriteArr(EEPROM_Array_ADDR, 4, EEPROM_Array);
	}
}

/*
 * @name   FLASH_WriteData
 * @brief  дһֽ(д֮ǰҪȲ)
 * @param  None
 * @retval None
 */
static void FLASH_WriteData(uint8_t dat, uint16_t addr)
{
	EA = 0;		   //رж
	INSCON = 0x80; //òΪEEPROM
	IAP_DATA = dat;
	IAP_CMD = 0xF00F; // Flash
	IAP_ADDR = addr;
	IAP_CMD = 0xB44B; //ֽڱ
	IAP_CMD = 0xE11E; //һβ Զ
	INSCON = 0x00;	  //رдEEPROM
	EA = 1;
}

/*
 * @name   Flash_EraseBlock
 * @brief  (ÿΪ32ֽ)
 * @param  None
 * @retval None
 */
static void Flash_EraseBlock(uint16_t addr)
{
	EA = 0;			  //رж
	INSCON = 0x80;	  //òΪEEPROM
	IAP_CMD = 0xF00F; // Flash
	IAP_ADDR = addr;  //дַ
	IAP_CMD = 0xD22D; //ѡʽ
	IAP_CMD = 0xE11E; //IAP_ADDRL&IAP_ADDRHָ0xFF,ͬʱԶ
	INSCON = 0x00;	  //رEEPROM
	EA = 1;
}
/*
 * @name   Flash_WriteArr
 * @brief  дһ
 * @param  address len savearray
 * @retval None
 */
static void Flash_WriteArr(unsigned int fui_Address, unsigned char fuc_Length, unsigned char *fucp_SaveArr)
{
	unsigned char fui_i = 0;
	EA = 0;
	for (fui_i = 0; fui_i < fuc_Length; fui_i++)
	{
		FLASH_WriteData(*(fucp_SaveArr++), fui_Address++);
	}
	EA = 1;
}
/*
 * @name   Flash_ReadArr
 * @brief  һ
 * @param  address len savearray
 * @retval None
 */
static void Flash_ReadArr(unsigned int fui_Address, unsigned char fuc_Length, unsigned char *fucp_SaveArr)
{
	INSCON = 0x80;
	while (fuc_Length--)
		*(fucp_SaveArr++) = *((unsigned char code *)(fui_Address++)); //ȡ
}
/********************************************************
  End Of File
********************************************************/