/*
 * PWM.c
 *
 *  Created on: 20220312
 *      Author: User
 */

/* Includes ------------------------------------------------------------------*/
#include <main.h>

/* Private define-------------------------------------------------------------*/
#define CCP_S1 BIT5
#define CCP_S0 BIT4

#define EPC0H BIT1
#define EPC0L BIT0

/* Private variables----------------------------------------------------------*/

/* Private function prototypes------------------------------------------------*/
static void PWM_Init(void);						  // PWMʼ
static void PWM1_HeatingSetting(uint8_t Percent); //ͨ1ü
static void PWM2_HeatingSetting(uint8_t Percent); //ͨ2ü
/* Public variables-----------------------------------------------------------*/
PWM_t PWM =
	{0,
	 0,
	 PWM_Init,
	 PWM1_HeatingSetting,
	 PWM2_HeatingSetting};

/*
 * @name   PWM_Init
 * @brief  PWMʼ
 * @param  None
 * @retval None
 */
static void PWM_Init()
{
	PWM0_MAP = 0x22;  // PWM0ͨӳP22
	PWM01_MAP = 0x23; // PWM01ͨӳP23
	PWM0C = 0x01;	  // PWM0Ч PWM01Ч ʱ8Ƶ

	//ģʽ£PWM0PWM01һڼĴ
	// PWM0ռձȵʹ			PWM0ռձȼĴ
	// PWM01ռձȵʹ			PWM0Ĵ

	//ڼ 	= 0x03ff / (Fosc / PWMƵϵ)
	//			= 0x03ff / (16000000 / 8)
	// 			= 1023   /2000000
	//			= 511.5us		   	Լ1.955kHz

	PWM0PH = 0x03; //ڸ4λΪ0x03
	PWM0PL = 0xE7; //ڵ8λΪ0xFF

	//ռձȼ= 0x0155 / (Fosc / PWMƵϵ)		FoscϵͳʱõĲ֣
	//			= 0x0155 / (16000000 / 8)
	// 			= 341 	 / 2000000
	//			= 170.5us		   ռձΪ 170.5/511.5 = 33.3%
	PWM0DH = 0x00;	// PWM04λռձ
	PWM0DL = 0x00;	// PWM04λռձ
	PWM0DTH = 0x00; // PWM014λռձ
	PWM0DTL = 0x00; // PWM018λռձ
	PWM0EN = 0x0F;	//ʹPWM0 ڶģʽ
}

/*
 * @name   PWM1_HeatingSetting
 * @brief  ȹ
 * @param  None
 * @retval None
 */
static void PWM1_HeatingSetting(uint8_t Percent)
{
	uint16_t Temp_Value = 0;
	Temp_Value = Percent * 10;
	if (Public.Channel1_StatusFlag != FALSE)
	{

		if (Channel1_Error_Flag != System_Fault) //жǷ
		{

			if (Percent == 0)
			{
				PWM.Heating_Flag1 = System_Complete;//¶Ѿ
			}
			else
			{
				PWM.Heating_Flag1 = TRUE;		//ڼ
			}
		}
		else
		{
			PWM.Heating_Flag1 = System_Fault;
		}
		
	}
	else
	{
		PWM.Heating_Flag1 = FALSE;
	}

	PWM0DTH = (Temp_Value >> 8) & 0xFF;
	PWM0DTL = (Temp_Value & 0xFF);
}

/*
 * @name   PWM2_HeatingSetting
 * @brief  ȹ
 * @param  None
 * @retval None
 */
static void PWM2_HeatingSetting(uint8_t Percent)
{
	uint16_t Temp_Value = 0;
	Temp_Value = Percent * 10;
	if (Public.Channel2_StatusFlag != FALSE)
	{

		if (Channel2_Error_Flag != System_Fault) //жǷ
		{
			if (Percent == 0)
			{
				PWM.Heating_Flag2 = System_Complete;	//¶Ѿ
			}
			else
			{
				PWM.Heating_Flag2 = TRUE;	//ڼ
			}
		}
		else
		{
			PWM.Heating_Flag2 = System_Fault;
		}
		
	}
	else
	{
		PWM.Heating_Flag2 = FALSE;
	}

	PWM0DH = (Temp_Value >> 8) & 0xFF;
	PWM0DL = (Temp_Value & 0xFF);
}
/********************************************************
  End Of File
********************************************************/