/*
 * TM1650.c
 *
 *  Created on: 20220312
 *      Author: User
 */

#include <Main.h>

// ʾ
static xdata uint8_t tab[] = {
    0x3F, // 0
    0x06, // 1
    0x5B, // 2
    0x4F, // 3
    0x66, // 4
    0x6D, // 5
    0x7D, // 6
    0x07, // 7
    0x7F, // 8
    0x6F, // 9
    0x40, // 10 = -
    0x79, // 11 = E
    0x50, // 12 = r
    0x00, // 13 = Null
    0x09, // 14
    0x58, // 15 = c
    0x1c, // 16 = u
    0x63, // 17 = o
    0x39, // 18 = C
    0x5C, // 19 = o
    0x0f, // 20 = C
    0x61, // 21 = c
    0x71, // 22 = F
    0x37, // 23 = N
    0x77, // 24 = A
    0x10, // 25  |
    0x14  // 26  ||
};

static void Init(void);                                             // tm1650ʼ
static void TM1650_Set(IIC_t *Channel, uint8_t Add, uint8_t Value); //tm1650Ĵֵ

static void Display_OFF(IIC_t *Channel);   //ʾOFF ַ
static void Display_Close(IIC_t *Channel); //ʾʱر

void TM1650_Display(IIC_t *Channel, uint16_t Value, uint8_t dot); //ʾʹ

TM1650_t TM1650 = {
    1,
    Init,
    Display_OFF,
    Display_Close};

/*
 * @name   Init
 * @brief  1650ʼ
 * @param  None
 * @retval None
 */
static void Init(void)
{
    TM1650_Set(&IIC_1, 0x48, 0x31); //ͨ1 3 ʾ
}

/*
 * @name   TM1650_Set
 * @brief  1650д
 * @param  Channel Add Value
 * @retval None
 */
static void TM1650_Set(IIC_t *Channel, uint8_t Add, uint8_t Value)
{
    IIC_t *const COM = Channel;
    EA = 0;
    COM->start();      // iicʼ
    COM->write(Add);   // iicдܻߵַ
    COM->ACK();        //ȴӦź
    COM->write(Value); // iicдݻʾ
    COM->ACK();        //ȴӦź
    COM->stop();       // iicֹͣ
    EA = 1;
}

/*
 * @name   TM1650_Set
 * @brief  1650ʾ
 * @param  Channel Value CHANNEL
 * @retval None
 */
void TM1650_Display(IIC_t *Channel, uint16_t Value, uint8_t CHANNEL)
{
    IIC_t *const IIC = Channel;

    if (CHANNEL == 1) //жʾͨ
    {
        TM1650_Set(IIC, DIG1, tab[25]); //ʾ|
    }
    else
    {
        TM1650_Set(IIC, DIG1, tab[26]); //ʾ||
    }

    if (Value < 100)
    {
        TM1650_Set(IIC, DIG2, tab[13]); //¶Ȳ100 رλ
    }
    else
    {
        TM1650_Set(IIC, DIG2, tab[Value % 1000 / 100]);
    }
    TM1650_Set(IIC, DIG3, tab[Value % 100 / 10]);
    TM1650_Set(IIC, DIG4, tab[Value % 10 / 1]);

    // TM1650_Set(IIC, DIG1, tab[Value / 1000]);
    // TM1650_Set(IIC, DIG2, tab[Value / 100 % 10]);
    // TM1650_Set(IIC, DIG3, tab[Value / 10 % 10]);
    // TM1650_Set(IIC, DIG4, tab[Value / 1 % 10]);
}

/*
 * @name   Display_OFF
 * @brief  TM1650ʾOFF
 * @param  Channel
 * @retval None
 */
static void Display_OFF(IIC_t *Channel)
{
    IIC_t *const IIC = Channel;
    TM1650_Set(IIC, DIG1, tab[0]);  //һλʾO
    TM1650_Set(IIC, DIG2, tab[22]); //ڶλʾF
    TM1650_Set(IIC, DIG3, tab[22]); //λʾF
    TM1650_Set(IIC, DIG4, tab[13]); //λʾر
}
/*
 * @name   Display_Close
 * @brief  1650ʾر
 * @param  Channel
 * @retval None
 */
static void Display_Close(IIC_t *Channel)
{
    IIC_t *const IIC = Channel;
    TM1650_Set(IIC, DIG1, tab[13]); //رʾ
    TM1650_Set(IIC, DIG2, tab[13]); //رʾ
    TM1650_Set(IIC, DIG3, tab[13]); //رʾ
    TM1650_Set(IIC, DIG4, tab[13]); //رʾ
}
