/*
 * UART1.c
 *
 *  Created on: 20220312
 *      Author: User
 */

/* Includes ------------------------------------------------------------------*/
#include <Main.h>
//#include <Timer0.h>
/* Private define-------------------------------------------------------------*/

#define UART1_Send_LENGTH 10
#define UART1_Rec_LENGTH 10

/* Private variables----------------------------------------------------------*/

static uint8_t xdata ucSend_Buffer[UART1_Send_LENGTH] = {0x00};
static uint8_t xdata ucRec_Buffer[UART1_Rec_LENGTH] = {0x00};

/* Private function prototypes------------------------------------------------*/
static void Init(void);						//ڳʼ
static void SendData(uint8_t);				//ڷַ
static void SendArray(uint8_t *, uint16_t); //ڷ
static void SendString(uint8_t *);			//ڷַ
static void Protocol_Analy(void);			//Э

/* Public variables-----------------------------------------------------------*/
UART_t idata UART1 =
	{
		FALSE,
		FALSE,
		0,
		ucSend_Buffer,
		ucRec_Buffer,
		Init,
		SendData,
		SendArray,
		SendString,
		Protocol_Analy};

/*
 * @name   Init
 * @brief  1ʼ
 * @param  None
 * @retval None
 */
static void Init() // 9600bps@16MHz
{
	// P2M0 = P2M0 & 0xF0 | 0x20; // P20Ϊ
	// P0M2 = P0M2 & 0x0F | 0x80; // P05Ϊ
	TXD_MAP = 0x05; // TXDӳP05
	RXD_MAP = 0x20; // RXDӳP20
	BRTSEL = 0X00;	// UART1Ĳ:00 T4
	T4CON = 0x06;	// T4ģʽUART1ʷ

	//ʼ
	// = 1/16 * (T4ʱԴƵ / ʱ4ԤƵ) / (65536 - 0xFF98)
	//       = 1/16 * ((16000000 / 1) / 104)
	//		 = 9615.38(0.16%)

	//9600
	//Ƴֵ = (65536 - ((T4ʱԴƵ / ʱ4ԤƵ) * (1 / 16)) / )
	//		   = (65536 - (16000000 * (1 / 16) / 9600))
	//		   = (65536 - 104.167)
	//         = FF98

	TH4 = 0xFF;
	TL4 = 0x98;	  //9600
	SCON2 = 0x02; // 8λUARTʿɱ
	SCON = 0x10;  //н
	IE |= 0X10;	  //ʹܴж
	EA = 1;		  //ʹж
}

/*
 * @name   SendData
 * @brief  ַ
 * @param  dat:ַ
 * @retval None
 */
static void SendData(uint8_t dat)
{
	while (UART1.ucTX_Busy_Flag)
		;						 //ȴǰݷ
	UART1.ucTX_Busy_Flag = TRUE; //λæµ־
	SBUF = dat;					 //дUARTĴ
}

/*
 * @name   SendArray
 * @brief  ڷ
 * @param  p_Arr:׵ַLEN:ͳ
 * @retval None
 */
static void SendArray(uint8_t *p_Arr, uint16_t LEN)
{
	uint16_t i = 0;

	for (i = 0; i < LEN; i++)
	{
		UART1.UART_SendData(*(p_Arr + i));
	}
	while (UART1.ucTX_Busy_Flag)
		; //ȴݷ
}

/*
 * @name   SendString
 * @brief  ַ
 * @param  p_Str:ַ
 * @retval None
//  */
static void SendString(uint8_t *p_Str)
{
	while (*p_Str)
	{
		UART1.UART_SendData(*(p_Str++)); //͵ǰַ
	}
	while (UART1.ucTX_Busy_Flag)
		; //ȴݷ
}

// putcharַͺض
// extern char putchar(char c)
// {
// 	UART1.UART_SendData((uint8_t)c);
// 	return c;
// }

/*
 * @name   UART1_isr
 * @brief  1жϷ
 * @param  None
 * @retval None
 */
void UART1_isr() interrupt UART1_VECTOR
{

	if (RI)
	{
		RI = (bit)0; //жϱ־

		if (UART1.ucRec_Cnt < UART1_Rec_LENGTH)
		{
			ucRec_Buffer[UART1.ucRec_Cnt++] = SBUF;
		}

		UART1.ucRec_Flag = TRUE;
	}

	if (TI)
	{
		TI = (bit)0;				  //жϱ־
		UART1.ucTX_Busy_Flag = FALSE; //æµ־
	}
}

/*
 * @name   Protocol_Analy
 * @brief  Э
 * @param  None
 * @retval None
 */

static void Protocol_Analy(void)
{
	if (UART1.ucRec_Flag == TRUE)
	{
		//õ
		if (ucRec_Buffer[0] != 0)
		{

			Timer0.msDelay_Timer = 0;
			while (UART1.ucRec_Cnt < Protocol_Len)
			{

				if (Timer0.msDelay_Timer >= TIMER0_100mS) // 100msûн ѭ
					break;
			}

			//	Э
			Protocol.Analysis(&UART1); //Э鴦
		}

		//
		Public.Memory_Clr(ucRec_Buffer, (uint16_t)UART1.ucRec_Cnt);
		//½
		UART1.ucRec_Cnt = 0;	  //ռ
		UART1.ucRec_Flag = FALSE; //ձ־λȡ
	}
}
/********************************************************
  End Of File
********************************************************/